void plotall(const char *fname="result.root") 
{
  TFile *inFile = TFile::Open(fname);

  char varstr[100];
  char cutstr[100];
  sprintf(cutstr,"iSync>200&&iSync<300");
  char filestr[100];

  TTree *tree = (TTree*) inFile->Get("tree");

  TCanvas *c1 = new TCanvas("c1","c1");
  c1->SetLogy();

  int j=0;
  for (j=0; j<6; j++) {
    c1->cd();
    sprintf(varstr, "fVRef[%d]", j);
    sprintf(filestr, "png/cuts/VRef%d.png", j);
    tree->Draw(varstr, cutstr);
    c1->SaveAs(filestr);
  }

  for (j=0; j<5; j++) {
    c1->cd();
    sprintf(varstr, "fVCurr[%d]", j);
    sprintf(filestr, "png/cuts/VCurr%d.png", j);
    tree->Draw(varstr, cutstr);
    c1->SaveAs(filestr);

    sprintf(varstr, "fACurr[%d]", j);
    sprintf(filestr, "png/cuts/ACurr%d.png", j);
    tree->Draw(varstr, cutstr);
    c1->SaveAs(filestr);
  }

  // all channels together
  const int kNTypes = 6;
  const char *typestr[] = { "Gain", "RT", "Ped", "Rms", "PedAna", "RmsAna" };

  int t=0;
  for (t=0; t<kNTypes; t++) {
    for (j=2; j<4; j++) {
      c1->cd();
      sprintf(varstr, "f%s%d0mV", typestr[t], j);
      sprintf(filestr, "png/cuts/%s%d0mV.png", typestr[t], j);
      tree->Draw(varstr, cutstr);
      c1->SaveAs(filestr);
    }
  }

  // other variables
  const int kNMisc = 4;
  const char *miscstr[] = { "X20mVeven", "X20mVodd", "X30mVeven", "X30mVodd" }; 

  for (t=0; t<kNMisc; t++) {
    c1->cd();
    sprintf(varstr, "f%s", miscstr[t]);
    sprintf(filestr, "png/cuts/%s.png", miscstr[t]);
    cout << " varstr " << varstr
	 << " filestr " << filestr << endl;
    tree->Draw(varstr, cutstr);
    c1->SaveAs(filestr);
  }

  c1->cd();
  tree->Draw("iSync", cutstr);
  c1->SaveAs("png/cuts/Sync.png");

}
