#!/bin/bash

if [ -z "$1" ]
  then
    echo "No file argument supplied"
    exit
fi


FILE=$1
 
DIR=`dirname $1`
ROOTFILE=`basename $1`
DESCRIPT=`basename $1 | sed 's/\.root//'` # skip suffix
CHIP=`echo ${DESCRIPT} | awk -F\_ '{print $NF}'` 

echo DIR ${DIR}
echo ROOTFILE ${ROOTFILE}
echo DESCRIPT ${DESCRIPT}
echo CHIP ${CHIP}

RESULTDIR="png/calib/${CHIP}"
echo RESULTDIR="${RESULTDIR}"

mkdir -p ${RESULTDIR}

TMPLINK="SAMPA_test.root"
TMPRESULT="results.root" 
TMPPLOT="SAMPA_noise.pdf" 
TMPTXT="ns_vs_chNo.txt" 

RESULTPLOT="noise_vs_chan_chip_${CHIP}.pdf" 
RESULTTXT="noise_vs_chan_chip_${CHIP}.txt" 

/bin/rm -f ${TMPLINK} ${TMPRESULT}
/bin/ln -s ${FILE} ${TMPLINK} 

#.L pedmem.cpp
 
root.exe -b << EOF
.L Noise-anal_sampa_dataCh_fit.cpp+
anl_tree("${TMPLINK}")
hist_anal()
SaveHST("${TMPRESULT}")  
.q
EOF
#

mv ${TMPPLOT} ${RESULTDIR}/${RESULTPLOT}
mv ${TMPTXT} ${RESULTDIR}/${RESULTTXT}

# some user feedback
cat ${RESULTDIR}/${RESULTTXT}
#echo "display ~/rootfiles/${RESULTDIR}/${RESULTPLOT}"
display ${RESULTDIR}/${RESULTPLOT} &
