#!/bin/bash

if [ -z "$1" ]
  then
    echo "No chip argument supplied"
    exit
fi
CHIP=$1

ls calib_*/*noise_${CHIP}.root | tail -1 | awk '{print "./processNoise.sh "$1}' > runNoise.sh
source runNoise.sh >& runNoise.log

### CALIB STUFF ###
#./processCalib.sh $1 >& tmp.log 
./processStaircase.sh $1 >& tmp.log 

# show a display of an example plot
PLOTFILE=`grep chan_01.png tmp.log | awk '{print $6}'`
echo "showing $PLOTFILE"
display $PLOTFILE &

# dump of text values
echo "All values"
 grep ichip tmp.log | grep -v png | awk '{print $2" "$4" "$7}' 
echo "all count"
 grep ichip tmp.log | grep -v png | awk '{print $2" "$4" "$7}' | wc -l
echo "Problematic values"
 grep ichip tmp.log | grep -v png | awk '{if ($7<8 || $7>10.2) print $2" "$4" "$7}'
echo "problem count"
 grep ichip tmp.log | grep -v png | awk '{if ($7<8 || $7>10.2) print $2" "$4" "$7}' | wc -l
 
