#!/bin/bash

if [ -z "$1" ]
  then
    echo "No chip argument supplied"
    exit
fi
chip=$1
HERE=`pwd`
# do tests & collect data
echo "START TESTS AND DATA-TAKING"
./testsetup-dev.sh >& ${HERE}/logs/test-chip${chip}.log
echo "TESTS AND DATA-TAKING DONE"
./testsetup-DFT.sh >& ${HERE}/logs/testDFT-chip${chip}.log &

# copy files to storage
echo "START COPYING FILES"
#pushd /home/alice/work/sampa/bin/833/ # old version, with TSocket
pushd /export1/alice/sampa/tests/MPW3/analyzer # Ulf version, with unix socket
# show display with signals in all 32 channels
display c2.pdf &
 
/home/alice/MPW3/copyChipFiles $chip >& ${HERE}/logs/copy-chip${chip}.log
popd
echo "COPYING DONE"

# analyze files 
echo "START ANALYSIS"
cd /home/alice/rootfiles
./test.sh $chip >& $HERE/logs/ana-chip$chip.log
cd -
echo "ANALYSIS DONE"

# check log files, and update logs/summary.csv
perl checklog.pl $chip 

