date
# 1) POWER ON  - manual
# +2) Run control - send DAQ command - Reset FPGA and SAMPA - OK at timeout
# +3) SOCFG 14 - 1B
# +3) Set number of serial links = 11
# +5) Enable all 11 links
# 6) Send SAMPA command - soft reset
# 7) Fix serial synk problems - update status => COMMUNICATOR
# 8) Pulse High : 2
#    Pulse low: 498
#    Check continous
#    CLick trigger
#
#---- TO DO
# socfpga: restart sampa server
#
# Run control tab: continous trigger mode
# status tab: fix serial sync problems
# run control tab: external pulser continous
#
# data taking: sampa analyzer
# data taking: testnoise.sh
# data taking: close sampa analyzer - generate root file.
#
# tests tab: check PCCA, skip hadd and clk config, print single rows, beep
# tests tab: run all
#
# tests tab: deselect PCCA
# socfpga: ./run-dft
# ---

#a bit extra sleep to allow time to come up
sleep 3

# figure out which device we could be talking to:
device=/dev/ttyUSB0
if [ -e $device ]
then
    echo "USB0"
else
    device=/dev/ttyUSB1
    echo "USB1"
fi
devshort=`echo $device | awk -F\tty '{print $2}'`
echo device $device
echo devshort $devshort

vxipath=$HOME/work/vxi11/bin
sampapath=/export1/alice/sampa/tests/MPW3

# 11 serial links sampa global register 12 value 1B OK
$sampapath/rdwrreg --sampa 0 --global --register 12 --write 1B --device $device
sleep 1
# see if board is alive, so we don't have to wait for it later
./waitSsh.sh 1
 
# 1 packet noClearFifo  noAcquire noDAS enable all links OK
$sampapath/rdwrreg --dm --register 0 --write 107FF --device $device
sleep 1

# set "Continous trigger mode" register VACFG register 0x0D bit 0 OK
$sampapath/rdwrregpos --sampa 0 --global --register D --mask 1 --position 0 --write 1 --device $device
# soft reset to sampa OK
$sampapath/rdwrreg --sampa 0  --register E --write 5 --device $device
sleep 1
# fix serial sync OK? 
$sampapath/fixserialsync --sampa 0 --log --device $device
sleep 1

# set Pulse low value = 498 (1F2 hex) OK
$sampapath/rdwrregpos --cnc --register 4 --mask 1FFF --position 0 --write 1F2 --device $device
# set triggering - continous - pulses = 0
$sampapath/rdwrreg --cnc --register 3 --write 80000006 --device $device
sleep 1

#pushd /home/alice/work/sampa/bin/833/ # old version, with TSocket
pushd /export1/alice/sampa/tests/MPW3/analyzer # Ulf version, with unix socket


# Data taking #1: pedestals
# execute remote commands on sockit - restart sampa server
ssh -t -t sampa@192.168.0.20 "su -c '/etc/init.d/sampa restart'"
# Run analyzer
./SAMPA_analyzer >& sampa_analyzer_noise.log &
# wait for program to establish connection; allow for maximum 20 sec
/home/alice/MPW3/waitConnected.sh 20
#run testprogram
/home/alice/work/sampa/bin/testnoise.sh.$devshort
# wait for data taking to be finished; allow for maximum 10 sec
/home/alice/MPW3/waitData.sh 10
#kill analyser
killall -s SIGINT SAMPA_analyzer

sleep 2
# Data taking #2: calibration
# execute remote commands on sockit - restart sampa server
ssh -t -t sampa@192.168.0.20 "su -c '/etc/init.d/sampa restart'"
# Run analyzer
./SAMPA_analyzer >& sampa_analyzer_calib.log &
# wait for program to establish connection; allow for maximum 20 sec
/home/alice/MPW3/waitConnected.sh 20
#run testprogram
#DS /home/alice/work/sampa/bin/testamplitude.sh.$devshort
/home/alice/work/sampa/bin/teststaircase.sh.$devshort
# wait for data taking to be finished; allow for maximum 10 sec
/home/alice/MPW3/waitData.sh 10
#kill analyser
killall -s SIGINT SAMPA_analyzer

popd # go back

#exit #tmp, if we want to skip later tests

# run all tests - afterwards is PCCA deselected
#$sampapath/runtests --all --device $device
#May 15: new jtagtest first, rest via runtests
$sampapath/jtagtest $device
$sampapath/runtests --baseline --memory --ring --device $device

# DFT part moved to a separate script

echo "DONE"
date
exit
