#!/bin/bash
if [ -z ${3+x} ]; then
    echo "three arguments needed: chipnum sweep mV";
    echo "example usage (for chip 138 sweep #2 20 mV/fC setting):";
    echo "./showSweep.sh 138 2 20";
    exit
fi

chip=$1
sweep=$2
config=$3

# look first in the local dir
filename="png/calib/V2/${chip}/sweep_${sweep}_chip_${chip}_${config}mV_noise.png"
if [ -f $filename ]; then
   echo "File $filename exists."
else
    filename="../ana/png/calib/V2/${chip}/sweep_${sweep}_chip_${chip}_${config}mV_noise.png"
#otherwise in ../ana dir
    if [ -f $filename ]; then
	echo "File $filename exists."
    else
	echo "File $filename does not exist."
	exit
    fi
fi

echo "displaying $filename ..."
display $filename
