# HDLC Core Repository


## HDLC Sw
The HDLC software core (gbt_hdlc_sw) implements a shift register based transmission and reception of HDLC frame
data. The RX path provides HDLC flag detection. Bitstuffing, de-bitstuffing, CRC calculation, etc is done in software.

The related software currently supports only HDLC-EC frames, and a single frame in flight.


## HDLC Light (DEPRECATED)

The HDLC light core (gbt_hdlc_light) implements a stripped-down HDLC protocol to establish the communication with
the GBT SCA from a readout-out card via the GBT. It is optimized for low resources usage,
and therefore only supports a single HDLC frame in flight.

Currently, only HDLC-EC frames are targeted.


## Project Structure
 * [hdl](./hdl) Hardware sources
   * [README.md](./hdl/README.md) Hardware-related README
 * [sim](./sim) Simulation files
   * [hdl](./sim/) HDL related to simulation
   * [README.md](./sim/README.md) Simulation README
 * [src](./src) Core-related software
   * [README.md](./src/README.md) Software-related README
