### HDLC Sw Interface

#### Core signals and generics of the `hdlc_sw` core:

- `SHREG_WIDTH`<br/>
  Defines with of the shift registers, 256 is a good choice for HDLC-EC

- `tx_data(SHREG_WIDTH-1 .. 0)`<br/>
  Transmit data register
- `tx_start`<br/>
  Triggers transmission of Tx data register content, edge-sensitive
- `tx_done`<br/>
  Goes low while frame transmission is ongoing

- `rx_data(SHREG_WIDTH-1 .. 0)`<br/>
  Receive data register
- `rx_done`<br/>
  Raised high as soon as HDLC flag inidicating the start of a frame is
  detected in the shift register, and stays high until frame reception
  is acknowledged
- `rx_ack`<br/>
  Acknowledge reception of the frame, and enable reception of next frame

- `rx_2b(1 .. 0)`<br/>
  GBT frame Rx bits
- `tx_2b(1 .. 0)`<br/>
  GBT frame Tx bits

- `rx_clk`, `tx_clk`<br/>
  GBT Rx/Tx frame clk
- `rx_rst`, `tx_rst`<br/>
  GBT Rx/Tx frame clock domain resets

#### Auxiliary signals:
- `rx_sw_seq_cnt`, `tx_sw_seq_cnt`<br/>
  Software-controlled Rx/Tx sequence counter
- `rx_sw_seq_inc`, `tx_sw_seq_inc`<br/>
  Increment software-controlled Rx sequence counter

- `tx_bitswap_sel`<br/>
  Swap GBT frame Tx bits at the output. Testing mainly, set to constant '0'/'1' in final application
- `rx_bitswap_sel`<br/>
  Swap GBT frame Rx bits at the input. Testing mainly, set to constant '0'/'1' in final application

- `rx_clr`, `tx_clr`<br/>
  Clear Rx/Tx domain related statistics, connect to '0' if not needed

- `rx_usr_rst`, `tx_usr_rst`<br/>
  Software-initiated option to reset the core, connected to '0' if not needed
