-- ------------------------------------------------------------------------------
-- Record types for HDLC software core
--
-- kirsch@fias.uni-frankfurt.de
-- ------------------------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

package gbt_hdlc_sw_types is
  constant HDLC_SW_SHREG_WIDTH : natural := 256;

  --
  -- Records grouped by IN/OUT and clock domains
  type t_gbt_hdlc_sw_ctrl_tx is record
    tx_frame       : std_logic_vector(HDLC_SW_SHREG_WIDTH-1 downto 0);
    tx_start       : std_logic;
    tx_clr         : std_logic;
    tx_bitswap_sel : std_logic;
    tx_usr_rst     : std_logic;
    tx_sw_seq_inc  : std_logic;
    --
    tx_mux_sel_dbg : std_logic;
  end record;

  type t_gbt_hdlc_sw_ctrl_rx is record
    rx_ack         : std_logic;
    rx_clr         : std_logic;
    rx_bitswap_sel : std_logic;
    rx_usr_rst     : std_logic;
    rx_sw_seq_inc  : std_logic;
  end record;

  type t_gbt_hdlc_sw_stat_tx is record
    tx_done       : std_logic;
    tx_seq_cnt    : std_logic_vector(3 downto 0);
    tx_sw_seq_cnt : std_logic_vector(3 downto 0);
  end record;

  type t_gbt_hdlc_sw_stat_rx is record
    rx_frame      : std_logic_vector(HDLC_SW_SHREG_WIDTH-1 downto 0);
    rx_done       : std_logic;
    rx_seq_cnt    : std_logic_vector(3 downto 0);
    rx_sw_seq_cnt : std_logic_vector(3 downto 0);
    rx_sof_cnt    : std_logic_vector(7 downto 0);
  end record;

end gbt_hdlc_sw_types;
