do add_signals_ref.tcl 

proc add_wave_hdlc_light_rx {{gname "DUT2_HDLC_LIGHT"} {path "sim:/tb/DUT2"}} {
  # RX
  add wave -group $gname \
      -group "Rx" \
      $path/rx_2b \
      $path/rx_enable \
      -color "Magenta" $path/cstate_rx -color "Green" \
      -unsigned $path/rx_seq_nr -hex \
      $path/rx_sof_det \
      $path/rx_abort_det \
      $path/rx_balign \
      $path/rx_svl_cmd_flag \
      $path/rx_frame_rdy_flag

  # RX CRC
  add wave -group $gname \
      -group "Rx CRC" -hex \
      -color "Magenta" $path/cstate_rx -color "Green" \
      $path/rx_crc_clr \
      $path/rx_binf_inc \
      $path/rx_binf_cnt \
      $path/rx_byte_c_rbo \
      -color "Blue" $path/rx_hdlc_fcs_recalc -color "Green" \
      $path/rx_hdlc_fcs_c_rbo \
      -color "Yellow" $path/rx_hdlc_fcs

  # RX de-bitstuff
  add wave -group $gname \
      -group "Rx de-bitstuff" -hex \
      $path/rx_dbts_enable \
      $path/rx_dbts_req \
      $path/rx_dbts_inh \
      $path/rx_ccnt_inh \
      $path/rx_shift_reg \
      $path/rx_balign
}

proc add_wave_hdlc_light_tx {{gname "DUT2_HDLC_LIGHT"} {path "sim:/tb/DUT2"}} {
  # Tx
  add wave -group $gname -group "Tx" \
      -color "Yellow" $path/tx_request -color "Green" \
      -hex $path/tx_mode \
      -hex $path/tx_addr \
      -color "Magenta" $path/cstate_tx -color "Green" \
      -unsigned $path/tx_seq_nr -hex \
      -unsigned $path/tx_bcnt -hex \
      $path/tx_bcnt_inh \
      $path/tx_bcnt_dec \
      $path/tx_2b
  
  # Tx bitstuff
  add wave -group $gname \
      -group "Tx bitstuff" -hex \
      -color "Magenta" $path/cstate_tx -color "Green" \
      $path/bts_enable \
      $path/tx_shift_load \
      $path/tx_shift_reg_c \
      $path/tx_shift_reg \
      $path/tx_bcnt_inh \
      $path/tx_shift \
      $path/tx_history \
      $path/bts_req \
      $path/bts_flag \
      $path/bts_select \
      $path/tx_history
  
  # Tx CRC 
  add wave -group $gname \
      -group "Tx CRC" -hex \
      -color "Magenta" $path/cstate_tx -color "Green" \
      $path/tx_crc_clr \
      $path/tx_frame_shift8 \
      $path/tx_frame_c \
      -color "Yellow" $path/tx_hdlc_fcs
}

#--------------------------------------------------------------------------------
add wave -position insertpoint -group "TB" -hex \
    sim:/tb/s_reset \
    sim:/tb/s_clk_40 \
    sim:/tb/s_sca_tx \
    sim:/tb/s_sca_rx \
    sim:/tb/s_sc_tx \
    sim:/tb/s_sc_rx \
    sim:/tb/s0_to_sca \
    sim:/tb/s0_from_sca \
    sim:/tb/s1_to_sca \
    sim:/tb/s1_from_sca

add wave -group "HDLC_LIGHT" -hex \
    sim:/tb/gsl*

#--------------------------------------------------------------------------------
set g "DUT2_HDLC_LIGHT"
add wave -group $g -hex \
    sim:/tb/DUT2/tx_rst \
    sim:/tb/DUT2/rx_rst \
    sim:/tb/DUT2/tx_clk \
    sim:/tb/DUT2/rx_clk

add_wave_hdlc_light_tx $g "sim:/tb/DUT2"
add_wave_hdlc_light_rx $g "sim:/tb/DUT2"

add wave -group $g -group "ALL" -hex \
    sim:/tb/DUT2/*

add wave -divider ""

#-------------------------------------------------------------------------------
add wave -group "HDLC_DUMP_LIGHT" -hex \
    sim:/tb/dump2/*

add wave -divider ""

#-------------------------------------------------------------------------------
set g "DUT3_HDLC_LIGHT"
add wave -group $g -hex \
    sim:/tb/DUT3/tx_rst \
    sim:/tb/DUT3/rx_rst \
    sim:/tb/DUT3/tx_clk \
    sim:/tb/DUT3/rx_clk

add_wave_hdlc_light_tx $g "sim:/tb/DUT3"
add_wave_hdlc_light_rx $g "sim:/tb/DUT3"

add wave -divider ""


#-------------------------------------------------------------------------------
add_wave_gbt_sca_verilog "GBT_SCA_VERILOG0" "sim:/tb/DUT0"

add wave -group "HDLC_DUMP_DUT0" -hex \
    sim:/tb/dump0/*

add wave -divider ""

add_wave_gbt_sca_verilog "GBT_SCA_VERILOG1" "sim:/tb/DUT1"
