do func.tcl

# Test data
#   longer sequences of 1s to test bitstuffing
quietly set test_data_bitstuff { \
  0xaffed00f \
  0xdeadbeaf \
  0xfffffffd \
  0x7fffffff \
  0xefffffff \
  0xcfffffff \
  0x3fffffff \
  0x1fffffff \
  0x0fffffff \
  0xf7ffffff \
  0xfeffffff \
  0xfcffffff \
  0xf3ffffff \
  0xf1ffffff \
  0xf0ffffff \
  0x7fffff7f \
  0xefffffef \
  0xcfffffcf \
  0x3fffff3f \
  0x1fffff1f \
  0x0fffff0f \
  0xf7fffff7 \
  0xfedffffd \
  0xfcfffffc \
  0xf3fffff3 \
  0xf1fffff1 \
  0xf0fffff0 \
  0xffffefff \
  0x7fffefff \
  0xefffefff \
  0xcfffefff \
  0x3fffefff \
  0x1fffefff \
  0x0fffefff \
  0xf7ffefff \
  0xfeffefff \
  0xfcffefff \
  0xf3ffefff \
  0xf1ffefff \
  0xf0ffefff \
  0x7fffef7f \
  0xefffefef \
  0xcfffefcf \
  0x3fffef3f \
  0x1fffef1f \
  0x0fffef0f \
  0xf7ffcff7 \
  0xfeffeffe \
  0xfcffeffc \
  0xf3ffeff3 \
  0xf1ffeff1 \
  0xf0ffeff0 \
  0xffffffff \
  0x7ffffffe \
  0xeffffffe \
  0xcffffffe \
  0x3ffffffe \
  0x1ffffffe \
  0x0ffffffe \
  0xf7fffffe \
  0xfdfffffd \
  0xfcfffffd \
  0xf3fffffd \
  0xf1fffffd \
  0xf0fffffd \
  0x7fffff7e \
  0xefffffee \
  0xcfffffce \
  0x3fffff3e \
  0x1fffff1e \
  0x0fffff0e \
  0xf7fffffe \
  0xfefffffe \
  0xfcfffffe \
  0xf3fffffe \
  0xf1fffffe \
  0xf0fffffe \
  0xffffeffe \
  0x7fffeffe \
  0xefffeffe \
  0xcfffeffe \
  0x3fffeffe \
  0x1fffeffe \
  0x0fffeffe \
  0xf7ffeffe \
  0xfeffeffd \
  0xfcffeffe \
  0xf3ffeffe \
  0xf1ffeffe \
  0xf0ffeffe \
  0x7fffef7e \
  0xefffefee \
  0xcfffefce \
  0x3fffef3e \
  0x1fffef1e \
  0x0fffef0e \
  0xf7ffeffd \
  0xfeffeffd \
  0xfcffeffd \
  0xf3ffeffd \
  0xf1ffeffd \
  0xf0ffeffd \
  0x7ffffff7 \
  0xeffffff7 \
  0xcffffff7 \
  0x3ffffff7 \
  0x1ffffff7 \
  0x0ffffff7 \
  0xf7fffffd \
  0xfefffff7 \
  0xfcfffff7 \
  0xf3fffff7 \
  0xf1fffff7 \
  0xf0fffff7 \
  0x7fffff77 \
  0xefffffe7 \
  0xcfffffc7 \
  0x3fffff37 \
  0x1fffff17 \
  0x0fffff07 \
  0xf7ffeffd \
  0xfefffffd \
  0xfcfffffd \
  0xf3fffffd \
  0xf1fffffd \
  0xf0fffffd \
  0xffffeff7 \
  0x7fffeff7 \
  0xefffeff7 \
  0xcfffeff7 \
  0x3fffeff7 \
  0x1fffeff7 \
  0x0fffeff7 \
  0xf7ffaff7 \
  0xfeffeffd \
  0xfcffeffd \
  0xf3ffeffd \
  0xf1ffeffd \
  0xf0ffeff7 \
  0x7fffef77 \
  0xefffefe7 \
  0xcfffefc7 \
  0x3fffef37 \
  0x1fffef17 \
  0x0fffef07 \
  0xf7ffeff7 \
  0xfeffeff7 \
  0xfcffeff7 \
  0xf3ffeff7 \
  0xf1ffeff7 \
  0xf0ffeff7 \
  0x7ffffffa \
  0xeffffffa \
  0xcffffffa \
  0x3ffffffa \
  0x1ffffffa \
  0x0ffffffa \
  0xf7fffffa \
  0xfefffffa \
  0xfcfffffa \
  0xf3fffffa \
  0xf1fffffa \
  0xf0fffffa \
  0x7fffff7a \
  0xefffffea \
  0xcfffffca \
  0x3fffff3a \
  0x1fffff1a \
  0x0fffff0a \
  0xf7fdfffa \
  0xfefdfffa \
  0xfcfdfffa \
  0xf3fdfffa \
  0xf1fdfffa \
  0xf0fdfffa \
  0xffffeffa \
  0x7fffeffa \
  0xefffeffa \
  0xcfffeffa \
  0x3fffeffa \
  0x1fffeffa \
  0x0fffeffa \
  0xf7ffeffa \
  0xfeffeffa \
  0xfcffeffa \
  0xf3ffeffa \
  0xf1ffeffa \
  0xf0ffeffa \
  0x7fffef7a \
  0xefffefea \
  0xcfffefca \
  0x3fffef3a \
  0x1fffef1a \
  0x0fffef0a \
  0xf7ffdffa \
  0xfeffdffa \
  0xfcffdffa \
  0xf3ffdffa \
  0xf1ffdffa \
  0xf0ffdffa \
  0x7ffffff5 \
  0xeffffff5 \
  0xcffffff5 \
  0x3ffffff5 \
  0x1ffffff5 \
  0x0ffffff5 \
  0xf7fffff5 \
  0xfefffff5 \
  0xfcfffff5 \
  0xf3fffff5 \
  0xf1fffff5 \
  0xf0fffff5 \
  0x7fffff75 \
  0xefffffe5 \
  0xcfffffc5 \
  0x3fffff35 \
  0x1fffff15 \
  0x0fffff05 \
  0xf7fdfff5 \
  0xfefdfff5 \
  0xfcfdfff5 \
  0xf3fdfff5 \
  0xf1fdfff5 \
  0xf0fdfff5 \
  0xffffeff5 \
  0x7fffeff5 \
  0xefffeff5 \
  0xcfffeff5 \
  0x3fffeff5 \
  0x1fffeff5 \
  0x0fffeff5 \
  0xf7ffeff5 \
  0xfeffeff5 \
  0xfcffeff5 \
  0xf3ffeff5 \
  0xf1ffeff5 \
  0xf0ffeff5 \
  0x7fffef75 \
  0xefffefe5 \
  0xcfffefc5 \
  0x3fffef35 \
  0x1fffef15 \
  0x0fffef05 \
  0xf7ffdff5 \
  0xfeffdff5 \
  0xfcffdff5 \
  0xf3ffdff5 \
  0xf1ffdff5 \
  0xf0ffdff5 \
}

quietly set test_data_short { \
  0xaffed00f \
  0xdeadbeaf \
  0x7fffffff \
  0xefffffff \
  0x7fffffff \
  0xf7ffffff \
  0xf7ffefff \
}



#-------------------------------------------------------------------------------
# Test routines
#
proc test0 {} {
  # Basic, simple, short, incomplete test
  sca_send_request 0 0x1 0xad 0x02 0x04 0x11223344
  run 5 us
  sca_send_request 0 0x1 0xad 0x02 0x04 0xdeadaffe
  run 5 us
  sca_write_packet 0 0x020aff03 0x11223344
  run 3 us
  sca_write_packet 0 0x00007e03 0xffffffff
  run 3 us
  sca_write_packet 0 0x020b0203 0x55ff7e88
  run 3 us
  sca_write_packet 0 0x020c03ff 0x997ebbcc
  run 3 us
  sca_write_packet 0 0x00000103 0xddeeff00
  run 3 us
  sca_write_packet 0 0x020d0103 0xff7f7ffe
  run 3 us
  sca_write_packet 0 0x020e0103 0xf37f7f3e
  run 3 us
  sca_write_packet 0 0x020f0103 0xff37fe3f
  run 3 us
}



proc test_bitstuff {logfile {iterations -1} {seed 0}} {
  # More extensive tests supplying full sca_request data
  global test_data_bitstuff

  set id 1
  set iteration 0

  # Allow to set seed for random generator on request
  if {$seed != 0} {expr srand($seed)}

  foreach e $test_data_bitstuff {
    set sca_length 0x2
    set sca_trid $id
    set sca_command [expr (int(rand()*256) & 0xff)]
    set sca_channel [expr (int(rand()*256) & 0xff)]
    set sca_data $e

    puts $logfile "[format %05u $iteration]: trid=0x[format %02X $sca_trid] cmd=0x[format %02X $sca_command] channel=0x[format %02X $sca_channel] length=$sca_length data=0x[format %08X $sca_data]"

    incr id 2
    incr iteration
    sca_send_request 0 $sca_trid $sca_channel $sca_length $sca_command $sca_data
    run 6 us

    if {($iterations > 0) && ($iteration >= $iterations)} { break }
  }
}



proc test_rnd {logfile {iterations 1000} {seed 0}} {
  # Some testing with random values
  global test_data

  set iteration 0

  if {$seed != 0} {expr srand($seed)}

  while {1} {
    set sca_length  0x2
    set sca_trid    [expr (int(rand()*255) + 1)]
    set sca_command [expr (int(rand()*256) & 0xff)]
    set sca_channel [expr (int(rand()*256) & 0xff)]
    set sca_data    [expr ((int(rand()*0x10000) & 0xffff) << 16) | (int(rand()*0x10000) & 0xffff)]

    puts $logfile "[format %05u $iteration]: trid=0x[format %02X $sca_trid] cmd=0x[format %02X $sca_command] channel=0x[format %02X $sca_channel] length=$sca_length data=0x[format %08X $sca_data]"

    incr iteration
    sca_send_request 0 $sca_trid $sca_channel $sca_length $sca_command $sca_data
    run 6 us

    if {$iteration >= $iterations} { break }
  }
}

proc test_svl_cmds {logfile} {
  sca_send_svl_test 0
  puts $logfile "Sent SCA supervisory command: TEST"
  run 6 us
  sca_send_svl_connect 0
  puts $logfile "Sent SCA supervisory command: CONNECT"
  run 6 us
  sca_send_svl_reset 0
  puts $logfile "Sent SCA supervisory command: RESET"
  run 6 us
}
