library IEEE;
use IEEE.STD_LOGIC_1164.all;

library work;
use work.gbt_banks_user_setup.all;

package bus_pkg is
  type t_bit113_a is array (0 to 3) of std_logic_vector (112 downto 0);
  type t_bit112_a is array (0 to 3) of std_logic_vector (111 downto 0);
  type t_bit84_a is array (0 to 3) of std_logic_vector (83 downto 0);
  type t_bit80_a is array (0 to 3) of std_logic_vector (79 downto 0);
  type t_bit33_a is array (0 to 3) of std_logic_vector (32 downto 0);
  type t_bit32_a is array (0 to 3) of std_logic_vector (31 downto 0);
  type t_bit2_a is array (0 to 3) of std_logic_vector (1 downto 0);

  type gbt_bus_rec is record
    rx_frame_clk_ready    : std_logic_vector(3 downto 0);
    rx_frame_clk          : std_logic_vector(3 downto 0);
    mgt_ready             : std_logic_vector(3 downto 0);
    gbt_rx_ready          : std_logic_vector(3 downto 0);
    rx_isdata_flag        : std_logic_vector(3 downto 0);
    tx_clk_pll_lck        : std_logic;
    tx_frame_clk          : std_logic_vector(3 downto 0);
    --
    rx_data               : t_bit84_a;
    rx_extra_data_widebus : t_bit32_a;
  end record gbt_bus_rec;

  type gbt_bus_rec_a is array (0 to 3) of gbt_bus_rec;

  type gbt_sc_rx_rec is record
    clk   : std_logic;
    reset : std_logic;
  end record;

  type gbt_sc_tx_rec is record
    clk   : std_logic;
    reset : std_logic;
  end record;

  type sca_in_rec is record
    data : std_logic_vector(31 downto 0);
    add  : std_logic_vector(2 downto 0);
    wr_p : std_logic;
    rd_p : std_logic;
  end record;


  type sca_out_rec is record
    data     : std_logic_vector(31 downto 0);
    irq      : std_logic;
    ready    : std_logic;
    st_sm    : std_logic_vector(3 downto 0);
    data_dbg : std_logic_vector(31 downto 0);
    ack_dbg  : std_logic;
  end record;


  type ic_in_rec is record
    data       : std_logic_vector(7 downto 0);
    wr_p       : std_logic;
    rd_p       : std_logic;
    start_p    : std_logic;
    fifo_reset : std_logic;
  end record;


  type ic_out_rec is record
    data        : std_logic_vector(7 downto 0);
    val         : std_logic;
    data_count  : std_logic_vector(7 downto 0);
    wr_data_cnt : std_logic_vector(7 downto 0);
    dstr_cnt    : std_logic_vector(7 downto 0);
  end record;

end;
