library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_textio.all;
use std.textio.all;

entity sim_data_log is
  generic (
    filename : string := "sim_fifo.txt";
    width    : positive := 32
  );
  port (
    clk             : in std_logic;
    wr_data         : in std_logic_vector(width-1 downto 0);
    wr              : in std_logic
  );
end sim_data_log;

architecture arc of sim_data_log is

  file thefile     : text open write_mode is filename;

begin

  process(clk)
    variable theline : line;
  begin
    if rising_edge(clk) then
      if wr = '1' then
        write(theline, string'("# @"));
        write(theline, time'image(now));
        writeline(thefile, theline);

        write(theline, string'("0x"));
        hwrite(theline, wr_data, RIGHT, (wr_data'length+3)/4);
        writeline(thefile, theline);
      end if;
    end if;
  end process;


end arc;
